<template>
  <q-page class="">
    <div class="login" v-if="authStore.loggedIn === true">
      <h2>Bonjour {{ userObject?.userName }}</h2>
      <p>mail: {{ userObject?.mail }}</p>
      <p>comment: {{ userObject?.comment }}</p>
      <q-btn
        @click="popupFullSize = true"
        @click.prevent="editProfil"
        label="modifier le profil"
        type="button"
        color="primary"
        icon="edit"
      />
      <DevGeneral />
      <h3>graphiques</h3>
      <q-btn
        @click="popupFullSize = true"
        @click.prevent="graphic"
        label="afficher la vue graphique"
        type="button"
        color="primary"
        icon="bar_chart"
      />
      <h3>liste des champs</h3>
      <q-btn
        @click="popupFullSize = true"
        @click.prevent="addField"
        label="ajouter un champ"
        type="button"
        color="primary"
        icon="add"
      />
      <ul>
        <FieldList
          v-for="item in userObject?.champs || []"
          :key="item._id"
          :item="item"
          @edit="showEditDialog(item)"
          @preview="showPreviewDialog(item)"
        />
      </ul>
    </div>
    <div class="login" v-if="authStore.loggedIn === false">
      <h2>account</h2>
      <h3>Vous n'êtes pas connecter</h3>
    </div>
  </q-page>
</template>

<script>
import {
  defineComponent,
  ref,
  computed,
  reactive, /* stop */
} from 'vue';
import { useAuthStore } from 'src/stores/authStore.js';
import { useQuasar } from 'quasar';
import DevGeneral from 'components/DevGeneral.vue';
import FieldList from 'components/FieldList.vue';
import DialogGeneralVue from 'components/DialogGeneral.vue';
import DialogGeneralAddFieldVue from 'components/DialogGeneralAddField.vue';
import DialogGeneralEditFieldVue from 'components/DialogGeneralEditField.vue';
import DialogGeneralViewDataVue from 'components/DialogGeneralViewData.vue';
import DialogGeneralGraphicVue from 'components/DialogGeneralGraphic.vue';

export default defineComponent({
  name: 'EssentialLink',
  props: {
    id: {
      type: String,
      required: true,
    },
  },
  components: { DevGeneral, FieldList },
  setup(props) {
    const authStore = useAuthStore();
    const userObject = computed(() => authStore.userObject);
    const quasar = useQuasar();
    const popupFullSize = ref(false);
    const popupCalendars = ref(false);
    const maximizedToggle = ref(true);
    const maximizedToggleCal = ref(true);
    /* FUNCTION TO TAKE ONE CALENDAR AND ADD dateFormat */
    function calendarAddDateFormat(calendar) {
      const theDate = new Date(calendar.date);
      const year = theDate.getFullYear();
      let month = theDate.getMonth() + 1;
      if (month < 10) {
        month = `0${month}`;
      }
      let day = theDate.getDate();
      if (day < 10) {
        day = `0${day}`;
      }
      calendar.dateFormat = `${year}-${month}-${day}`;
      return calendar;
    }
    /* FUNCTION TO TRI obj IN array */
    function SortArray(y, x) {
      return x.date.localeCompare(y.date);
    }
    const windowObj = reactive({});
    const editProfil = () => {
      windowObj.title = 'modifier le profil';
      windowObj.type = 'editProfil';
      console.log('editProfil', windowObj);
      quasar.dialog({
        component: DialogGeneralVue,
        componentProps: { windowObj, userObject },
      });
    };
    const addField = () => {
      windowObj.title = 'ajoutez un champ';
      windowObj.type = 'addField';
      quasar.dialog({
        component: DialogGeneralAddFieldVue,
        componentProps: { windowObj, userObject },
      });
    };
    const graphic = () => {
      windowObj.title = 'vue graphique';
      windowObj.type = 'graphic';
      quasar.dialog({
        component: DialogGeneralGraphicVue,
        componentProps: { windowObj, userObject },
      });
    };
    function editField(field, fieldId) {
      windowObj.title = `editez le champ ${field.name}`;
      windowObj.type = 'editField';
      windowObj.id = fieldId;
      windowObj.name = field.name;
      windowObj.color = field.color;
      windowObj.comment = field.comment;
      quasar.dialog({
        component: DialogGeneralEditFieldVue,
        componentProps: { windowObj, userObject },
      });
    }
    const viewDataField = (cal, fieldId) => {
      windowObj.title = 'visualisation des données';
      windowObj.type = 'viewDataField';
      windowObj.cal = [];
      for (let i = 0; i < cal.length; i += 1) {
        const element = cal[i];
        const newElement = calendarAddDateFormat(element);
        windowObj.cal.push(newElement);
      }
      const orderWindowObj = windowObj.cal.sort(SortArray);
      windowObj.cal = orderWindowObj;
      windowObj.fieldId = fieldId;

      quasar.dialog({
        component: DialogGeneralViewDataVue,
        componentProps: { windowObj, userObject },
      });
    };
    async function showPreviewDialog(item) {
      popupFullSize.value = true;

      const requestOptionsConn = {
        method: 'GET',
        headers: {
          Authorization: `Bearer ${authStore.jwt}`,
        },
      };
      fetch(
        `${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${item._id}/calendar`,
        requestOptionsConn,
      )
        .then((response) => {
          if (response.status !== 200) {
            quasar.dialog({
              title: 'Alert',
              message: 'un problème est survenu ...',
            });
            throw response.status;
          }
          return response.json();
        })
        .then((json) => {
          console.log('json');
          console.log(json);
          viewDataField(json, item._id);
        });
    }
    const showEditDialog = (item) => {
      popupFullSize.value = true;
      editField(item, item._id);
    };
    return {
      authStore,
      props,
      jwt: authStore.jwt,
      userId: authStore.userId,
      loggedIn: authStore.loggedIn,
      userObject,
      popupFullSize,
      popupCalendars,
      maximizedToggle,
      maximizedToggleCal,
      editProfil,
      addField,
      graphic,
      editField,
      viewDataField,
      windowObj,
      showPreviewDialog,
      showEditDialog,
    };
  },
});
</script>
